#include "riffhead.hh"

/* STREAM FORMAT */

class strf: public RiffHead
{
public:
    virtual string Read(FILE *fp, unsigned bytes);
};

string strf::Read(FILE *fp, unsigned bytes)
{
    if(bytes == 16 || bytes == 18 || bytes == 30)
    {
        // wave format
        unsigned formattag = ReadW(fp); // 2
        unsigned chancount = ReadW(fp); // 4
        unsigned rate      = ReadDW(fp); // 8 
        unsigned bytesec   = ReadDW(fp); // 12
        unsigned align     = ReadW(fp); // 14
        unsigned bitness   = ReadW(fp); // 16
        if(bytes > 16)
        {
            unsigned cbsize    = ReadW(fp); // 18
        }

        char Buf[256];
        string result = string(Buf, sprintf(Buf,
            "Format 0x%X, %u-bit %u Hz %u chans (%u B/s)",
            formattag,
            bitness, rate, chancount, bytesec
        ));
        /*
        if(bytes > 18)
        {
            unsigned fourcc    = ReadDW(fp); // codec
            result += string(Buf, sprintf(Buf,
                " - %c%c%c%c(0x%08X)",
                (char)(fourcc&255),
                (char)((fourcc>>8)&255),
                (char)((fourcc>>16)&255),
                (char)((fourcc>>24)&255),
                fourcc
            ));
        }
        */
        return result;
    }
    
    //if(bytes == 0x48)
    {
        // video format
        unsigned sizehmm   = ReadDW(fp);
        unsigned width     = ReadDW(fp);
        unsigned height    = ReadDW(fp);
        unsigned planes    = ReadW(fp);
        unsigned depth     = ReadW(fp);
        unsigned fourcc    = ReadDW(fp); // codec
        unsigned size      = ReadDW(fp);
        unsigned a=ReadW(fp),b=ReadW(fp),c=ReadW(fp),d=ReadW(fp);
        
        char Buf[256];
        return string(Buf, sprintf(Buf,
            "%c%c%c%c(0x%08X), %ux%u(%u bits)",
            (char)(fourcc&255),
            (char)((fourcc>>8)&255),
            (char)((fourcc>>16)&255),
            (char)((fourcc>>24)&255),
            fourcc,
            width,height, depth
        ));
    }
    return "";
}

static class strfadder { public: strfadder() { RegisterFormat("strf", new strf); } } strfadder;
static class fmtadder { public: fmtadder() { RegisterFormat("fmt ", new strf); } } fmtadder;
